//========================================================================
//   "WebCrossword"  JavaScript Crossword 
//
//   Copyright (C) 2000,2003  Jan Mulder
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version, and as long as this notice is
//   kept unmodified at the top of the script source code.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License (license.txt) for more details.
//
//   Contact: Jan Mulder info@EnglishCafe.co.uk
//  
//   Last updated: 4th March 2003
//=======================================================================

///////////////////////////////////////////////////////////// <!-- ĉ -->
// Modified by Klivo (Cleve Lendon) in order to support Esperanto-crosswords
// 2003/5
// Modifita de Klivo por subteni Esperantajn krucenigmojn.
// 2003/5

doneLoading = false;
imageCount = 0;
var progressBar = '||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||';

// check for NS version 4 or less
var isNS4 = false;

if ( (navigator.appName == "Netscape") && ( (navigator.userAgent).indexOf("Gecko") == -1)  )
  isNS4 = true;  

function doFunction(aFunction)
{
 if (aFunction.indexOf('(') > -1)
   eval( aFunction );
 else
   eval(aFunction+'()');
}

tempArray = new Array();

function updateProgress(ims)
{
   var cnt=0;

   for(var i = 0; i < ims.length; i++)
      if(ims[i].complete || ims[i].errored) cnt++;

   if(ims.length > 0)
      window.status='Preparanta krucenigmon  ['+Math.round((cnt / imageCount)*100)+'%] ' + 
                               progressBar.substring(0, cnt);

   if(cnt < ims.length) {
      tempArray = ims;
      setTimeout("updateProgress(tempArray)",200);
   }
   else onComplete();
}

function onComplete()
{
 window.status='Done';
 doneLoading = true;
}

function preloadImages() {
   this.length = preloadImages.arguments.length;
   imageCount = this.length;
   for (var i = 0; i < this.length; i++) {
      this[i] = new Image();
      this[i].errored=false;
      this[i].onerror=new Function("this["+i+"].errored=true");
      this[i].src = preloadImages.arguments[i];
   }
   updateProgress(this);
}

krajonoa = new Image;
krajonoa.src = "krajonoa.gif";
krajonob = new Image;
krajonob.src = "krajonob.gif";
krajonoc = new Image;
krajonoc.src = "krajonoc.gif";

eraro = new Image;
eraro.src = "eraro.gif";
bona = new Image;
bona.src = "bona.gif";
gratulon = new Image;
gratulon.src = "gratulon.gif";

var pictures = new preloadImages(
 sourceDir+"black.gif", sourceDir+"white.gif", sourceDir+"travid.gif",
 sourceDir+"1.gif", sourceDir+"2.gif", sourceDir+"3.gif", sourceDir+"4.gif", sourceDir+"5.gif", sourceDir+"6.gif",
 sourceDir+"7.gif", sourceDir+"8.gif", sourceDir+"9.gif", sourceDir+"10.gif", sourceDir+"11.gif", sourceDir+"12.gif",
 sourceDir+"13.gif", sourceDir+"14.gif", sourceDir+"15.gif", sourceDir+"16.gif", sourceDir+"17.gif", sourceDir+"18.gif",
 sourceDir+"19.gif", sourceDir+"20.gif", sourceDir+"21.gif", sourceDir+"22.gif", sourceDir+"23.gif", sourceDir+"24.gif",
 sourceDir+"25.gif",
 sourceDir+"a.gif", sourceDir+"b.gif", sourceDir+"c.gif", sourceDir+"d.gif", sourceDir+"e.gif", sourceDir+"f.gif",
 sourceDir+"g.gif", sourceDir+"h.gif", sourceDir+"i.gif", sourceDir+"j.gif", sourceDir+"k.gif", sourceDir+"l.gif",
 sourceDir+"m.gif", sourceDir+"n.gif", sourceDir+"o.gif", sourceDir+"p.gif", sourceDir+"q.gif", sourceDir+"r.gif",
 sourceDir+"s.gif", sourceDir+"t.gif", sourceDir+"u.gif", sourceDir+"v.gif", sourceDir+"w.gif", sourceDir+"x.gif",
 sourceDir+"y.gif", sourceDir+"z.gif",
sourceDir+"cx.gif", sourceDir+"gx.gif", sourceDir+"hx.gif",
sourceDir+"jx.gif", sourceDir+"sx.gif", sourceDir+"ux.gif", 
sourceDir+"krajonoa.gif", sourceDir+"krajonob.gif", sourceDir+"krajonoc.gif",
sourceDir+"eraro.gif", sourceDir+"bona.gif", sourceDir+"gratulon.gif"
 );

function makePair(string, val)
{
 this.str = string;
 this.pos = val;
}

function fillArray(len, val)
{
 for (var i = 0; i < len; i++)
  this[i] = val;
}

function getPuzzleData(offset)
{
 for (var i = offset; i < (numAcross+numDown)*3; i = i+3)
 {
  if (i == offset)
    this[i-offset] = puzzleData[i];
  else
    this[(i-offset)/3] = puzzleData[i];
 }
}

var numDone = 0;
var originalSources = new Array();
var letterSources = new Array();
var locationData = new Array();
var solvedItems = new Array();
var solvedData = new fillArray(height*width, false);
var skribita = new fillArray(height*width, false);
var types = new getPuzzleData(0);
var clues = new getPuzzleData(1);
var words = new getPuzzleData(2);


// Klivo shanghis: nun cx, gx, ktp estas validaj literoj.
// Antaue, puzzleLayout havis ekzemple: 1ah, e, l, l, o...
// Nun, por litero, du signoj eblas: 1ajx, a, ux, d, o....

function loadSources() {
   for (var i = 0; i < puzzleLayout.length; i++)  {
      letter = puzzleLayout[i].toLowerCase();

      if (letter.charAt(0) >= '0' && letter.charAt(0) <= '9') {
         blockNumber = parseInt(letter);
         letter = letter.substring(('' + blockNumber).length, letter.length);
         direction = letter.charAt(0);
         letter = letter.substring(1);
         originalSources[i] = sourceDir + blockNumber + '.gif';
         //letterSources[i] = sourceDir + letter + '.gif';
         if (blockNumber <= 0) {
           alert('debug:loadSources() - Eraro dum legado de litero #' + i);
         }
         else {
            // Change d, a, b to v, h, a (vertikala, horizontala, ambau)
            // Sxangxu d, a, b al v, h, a (vertikala, horizontala, ambau)
            if ((direction == 'v') || (direction == 'a'))
               locationData[locationData.length] = new makePair(blockNumber + 'V', i);
            if ((direction == 'h') || (direction == 'a'))
               locationData[locationData.length] = new makePair(blockNumber + 'H', i);
         }
      }
      else {
         if (letter == '-') {
            originalSources[i] = sourceDir + 'black.gif';
            //letterSources[i] = sourceDir + 'black.gif';
         }
         else {
            originalSources[i] = sourceDir + 'white.gif';
            //letterSources[i] = sourceDir + letter + '.gif';
         }
      }
   } // end of for
}

function loadBackground() {
   for (i=0; i<height*width; i++)
      if (skribita[i]) eval("document.box"+i+".src = '"+originalSources[i]+"';");
}


// Pentru vortojn, solvitaj au ne.
function loadForeground() {
   for (i=0; i < height*width; i++) {
      if (skribita[i]) eval("document.box"+i+".src = '"+letterSources[i]+"';");
      else eval("document.box"+i+".src = '"+originalSources[i]+"';");
   }
}


function findIndex(clueTyp)
{
   for (var i = 0; i < (numAcross+numDown); i++) {
      if (locationData[i].str == clueTyp) return locationData[i].pos;
   }
   alert('debug:findIndex(): indekso ne trovita');
   return -1;
}

function checkSolved(iSolved)
{
  found = false;
  for (var i=0; i < solvedItems.length; i++)
    if (solvedItems[i] == iSolved)
      found = true;

  return found;
}



// Skribu writes whatever the player typed into the squares. No checking.
// 'Skribu' skribas kion ajn la ludanto tajpis en la kvadratojn. Ghi ne kontrolas.
function skribu(respondo, clueNum) {

    if (respondo == null) return false;

    userGuess = xigu(respondo);

// Klivo shanghis: 
// De nun supersignitaj literoj estos indikitaj per x (cxirkaux). 
// La longeco (wordLength) de 'cxirkaux' devas esti 6, ne 8.
// wordLength = words[clueNum].length;

   correctWord = words[clueNum];

   var maks = 0;
   var antaua  = '#';
   var lit;
   for (i = 0; i < correctWord.length; i++) {
      lit = correctWord.charAt(i);
      if (lit != 'x' || (lit == 'x' && !estas_cghjsu(antaua)))  maks++;
      antaua = lit;
   }

   var longeco = 0;
   antaua  = '#';
   for (i = 0; i < userGuess.length; i++) {
      lit = userGuess.charAt(i);
      if (lit != 'x' || (lit == 'x' && !estas_cghjsu(antaua))) longeco++;
      antaua = lit;
   } 

   if (longeco > maks) longeco = maks;

   var clueType = types[clueNum];
   clueIndex = findIndex(clueType);

   var skip = 1;
   if (clueNum >= numAcross) skip = width;

   var j = 0;
   var litero = '';
   for (var i = 0; i < maks; i++) {

      litero = userGuess.charAt(j); j++;

      if (litero < 'a' || litero > 'z') litero = 'travid';
      else if (j < userGuess.length && userGuess.charAt(j) == 'x' &&
         estas_cghjsu(litero)) {
         litero += 'x';
         j++;
      }

      if (i < longeco) {
         letterSources[clueIndex] = sourceDir + litero + '.gif';
         skribita[clueIndex] = true;
      }
      else {
         skribita[clueIndex] = false;
      }
      clueIndex += skip;
   }

   return (numDone == numAcross + numDown);
}


// Check one guess.
// Kontrulu unu respondon.
function kontrolu_unu(respondo, numero) {
   if (respondo == null) return false;
   var x = xigu(respondo).substring(0,words[numero].length);
   if (x == words[numero]) return true;
   return false;
}


// Control all guesses.
// Kontrolu chiujn respondojn.

function kontrolu() {
   var respondo = '';
   var nombro_da_respondoj = 0;
   var bonaj = 0;
   var malbonaj = 0;
   var totalo = (numAcross+numDown);
   for (var i = 0; i < totalo; i++) skribu("",i);
   for (var i = 0; i < totalo; i++) {
      respondo = document.formulo[i].value;
      if (respondo != null && respondo != '') {
         nombro_da_respondoj++;
         if (kontrolu_unu(respondo, i)) {
            skribu(respondo,i);
            eval('document.krajono' + i + '.src = bona.src;');
            bonaj++;
         }
         else {
            eval('document.krajono' + i + '.src = eraro.src;');
            malbonaj++;
         }
      }
   }
   //loadBackground();
   loadForeground();
   if (nombro_da_respondoj == totalo && malbonaj == 0) {
      // All correct.
      montru_gratulon();   // Show congratulations message.
   }
}


function montru_solvon() {
   var totalo = (numAcross+numDown);
   for (var i = 0; i < totalo; i++) {
      document.formulo[i].value = unikodigu(words[i]);
      eval('document.krajono' + i + '.src = krajonob.src;');
      skribu(words[i], i);
   }
   //loadBackground();
   loadForeground();
}


function skribilo(index)
{

   if (!doneLoading) {
      alert('La krucenigmo ankorau preparighas. Bonvolu atendi.');
      return;
   }

   skribu(document.formulo[index].value, index);
   //loadBackground();
   loadForeground();
}

function drawCrossword()
{
   window.defaultStatus = "";
   document.write('<center><table border="1" cellspacing=0 cellpadding=0 bgcolor="white">');
   for (var i = 0; i < height; i++) {
      document.write('<tr>');
      for (var j = 0; j < width; j++) {
         document.write('<td background="'+originalSources[i*width+j]+'">');
        document.write('<img src="'+originalSources[i*width+j]+'" width=21 ');
        document.write('height=21 name="box'+(i*width+j)+'"><br></td>');
      }
      document.write('</tr>');
   }
 document.write("</table><\/center>");
}

function drawAcross()
{
  document.writeln('<span class="heading"><b>Horizontale</b>:</span> <br>');

  document.writeln('<table border=0>');
  for (i = 0; i < numAcross; i++)
  {

      sekvanta = i + 1;
      if (sekvanta >= (numAcross + numDown)) sekvanta = 0;

      document.write('<tr><td valign="top" align="right">');
      document.writeln(types[i].substring(0, types[i].length-1) + '.');
      document.write('</td><td valign="top">');
      document.writeln('' + clues[i] + '&nbsp;');
      document.write('</td><td valign="top">');

      document.write('&nbsp;<input type=text size=10 ');
      document.write('name="respondo' + i + '"  ');
      document.write('onFocus = "fieldnum = ' + i + ';  ');
      document.write('nextfield = \'respondo' + sekvanta + '\';">');

      document.write('</td><td valign="top">');
      document.write('&nbsp;<a href="javascript:void(skribilo('+i+'))" ');
      document.write('onMouseOver="krajono' + i + '.src = krajonoc.src" ');
      document.write('onMouseOut="krajono' + i + '.src = krajonob.src">');
      document.writeln('<img src="krajonob.gif" border=0 name="krajono' + i + '"></a>');
      document.write('</td></tr>');
   }
   document.writeln('</table>');
}

function drawDown()
{
  document.writeln('<span class="heading"><b>Vertikale</b>:</span> <BR>');

  document.writeln('<table border=0>');
  for (i = numAcross; i < (numAcross+numDown); i++)
  {

      sekvanta = i + 1;
      if (sekvanta >= (numAcross + numDown)) sekvanta = 0;

      document.write('<tr><td valign="top" align="right">');
      document.writeln(types[i].substring(0, types[i].length-1) + '.');
      document.write('</td><td valign="top">');
      document.writeln('' + clues[i] + '&nbsp;');
      document.write('</td><td valign="top">');

      document.write('&nbsp;<input type=text size=10 ');
      document.write('name="respondo' + i + '"  ');
      document.write('onFocus = "fieldnum = ' + i + ';  ');
      document.write('nextfield = \'respondo' + sekvanta + '\';">');

      document.write('&nbsp;<a href="javascript:skribilo('+i+')" ');
      document.write('onMouseOver="krajono' + i + '.src = krajonoc.src" ');
      document.write('onMouseOut="krajono' + i + '.src = krajonob.src">');
      document.writeln('<img src="krajonob.gif" border=0 name="krajono' + i + '"></a>');
      document.write('</td></tr>');
   }
   document.writeln('</table>');
}


function drawCheckButton()
{
    document.write('&nbsp;<a class="simpla" href="javascript:kontrolu()" >');
    document.writeln('<b>Kontrolu<\/b><\/a>&nbsp;&nbsp;&nbsp;');
    document.write('&nbsp;<a class="simpla" href="javascript:montru_solvon()" >');
    document.writeln('<b>Montru Solvon<\/.b><\/a>');
    document.write('<div class="malgranda"><br><center>Notu: ŭ = ux = ^u<\/center><\/div>');
}


// Convert Esperanto words from Unicode or circumflex format to x format.
// Konvert Esperantajn vortojn de Unikodo au cirkumfleks-formato al x-formato.
function xigu(originalo) {
   longeco = originalo.length;
   ori = originalo.toLowerCase();
   nova = "";
   nova2 = "";
   litero = '';
   sekvanta = '';
   var m = 0;
   // konvertu ^c
   for (; m < longeco - 1; m++) {
      litero = ori.charAt(m);
      sekvanta = ori.charAt(m+1);
      if (litero == '^') {
         nova += sekvanta + 'x';
         m++;
      }
      else {
         nova += litero;
      }
   }
   if (m < longeco) {
         nova += ori.charAt(m);
   }
   // konvertu unikodon
   m = 0;
   for (; m < longeco; m++) {
      litero = nova.charAt(m);
      if (litero == '\u0109') {
         nova2 += 'cx';
      }
      else if (litero == '\u011d') {
         nova2 += 'gx';
      }
      else if (litero == '\u0125') {
         nova2 += 'hx';
      }
      else if (litero == '\u0135') {
         nova2 += 'jx';
      }
      else if (litero == '\u015d') {
         nova2 += 'sx';
      }
      else if (litero == '\u016d') {
         nova2 += 'ux';
      }
      else nova2 += litero;
   }
   return nova2;
}

function estas_cghjsu(la_litero) {
   if (la_litero == 'c') return true;
   if (la_litero == 'g') return true;
   if (la_litero == 'h') return true;
   if (la_litero == 'j') return true;
   if (la_litero == 's') return true;
   if (la_litero == 'u') return true;
   return false;
}



// Konvertu ^c kaj cx al unikodo.

function unikodigu(originalo) {
   if (originalo == null || originalo == '') return '';
   var longeco = originalo.length;
   var nova = "";
   var litero = '';
   var sekvanta = '';
   var uni_litero = '';
   var i = 0;
   for (; i < longeco - 1; i++) {
      litero = originalo.charAt(i);
      sekvanta = originalo.charAt(i+1);
      if (litero == '^') {
         uni_litero = aski_al_Unikodo(sekvanta);
         if (uni_litero != '*') {
            nova += uni_litero;
            i++;
         }
         else nova += litero;
      }
      else if (sekvanta == 'x' || sekvanta == 'X') {
         uni_litero = aski_al_Unikodo(litero);
         if (uni_litero != '*') {
            nova += uni_litero;
            i++;
         }
         else nova += litero;
      }
      else {
         nova += litero;
      }
   }
   if (i < longeco) {
         nova += originalo.charAt(i);
   }
   return nova;
}

function aski_al_Unikodo (litero) {
   if (litero <= 'z' && litero >= 'A') {
      if (litero == 'c') {
         return '\u0109'; 
      } else 
      if (litero == 'g') {
         return '\u011d'; 
      } else 
      if (litero == 'h') {
         return '\u0125'; 
      } else 
      if (litero == 'j') {
         return '\u0135'; 
      } else 
      if (litero == 's') {
         return '\u015d'; 
      } else 
      if (litero == 'u') {
         return '\u016d'; 
      } else 
      if (litero == 'C') {
         return '\u0108'; 
      } else 
      if (litero == 'G') {
         return '\u011c'; 
      } else 
      if (litero == 'H') {
         return '\u0124'; 
      } else 
      if (litero == 'J') {
         return '\u0134'; 
      } else 
      if (litero == 'S') {
         return '\u015c'; 
      } else 
      if (litero == 'U') {
         return '\u016c'; 
      } else {
         return '*';
      }
   }   // fino de if

   return '*';

}   // fino de aski_al_Unikodo








//<!-- Original:  Ronnie T. Moore -->
//<!-- Web Site:  The JavaScript Source -->
//<!-- This script and many more are available free online at -->
//<!-- The JavaScript Source!! http://javascript.internet.com -->

fieldnum = 0;
nextfield = "respondo0"; // name of first box on page
netscapex = "";
ver = navigator.appVersion; len = ver.length;
for(iln = 0; iln < len; iln++) if (ver.charAt(iln) == "(") break;
netscapex = (ver.charAt(iln+1).toUpperCase() != "C");

function keyDown(DnEvents) { // handles keypress
   // determines whether Netscape or Internet Explorer
   k = (netscapex) ? DnEvents.which : window.event.keyCode;
   if (k == 13) { // enter key pressed
      if (nextfield == 'done') {
         return true; // submit, we finished all fields
      }
      else { // we're not done yet, send focus to next box
         skribilo(fieldnum);
         eval('document.formulo.' + nextfield + '.focus()');
         return false;
      }
   }
}
document.onkeydown = keyDown; // work together to analyze keystrokes
//if (netscapex) document.captureEvents(Event.KEYDOWN|Event.KEYUP);
if (isNS4) document.captureEvents(Event.KEYDOWN);
// end of code by Ronnie T. Moore



// En Opera, premo de enig-klavo kauzas 'submit'-eventon. La sekvanta
// peco de skripto el http://www.cs.tut.fi/~jkorpela/forms/enter.html
// korektas tiun problemon.
function noenter() {
  return !(window.event && window.event.keyCode == 13); 
}
document.onkeypress = noenter;
// Noto: Devas esti onkeypress. onKeyPress ne funkcias.






// Display 'Gratulon' in a new window.
// Montru 'Gratulon' en nova fenestro.
function montru_gratulon() {

   var fen_alt = 120;
   var fen_lar = 360;
   var supro = 300;
   var maldeks = 300;
   var params = '';

   if(parseInt(navigator.appVersion) >= 4) {
       maldeks = (screen.width / 2) - (fen_lar / 2);
       supro = (screen.height / 2) - (fen_alt / 2);
   }

   params =    'top=' + supro + ',left=' + maldeks + ',width=' + fen_lar + ',height=' + fen_alt ;
   params +=  ',menubar=no,toolbar=no,location=no,';
   params +=  'directories=no,scrollbars=no,status=no,resizable=no;copyhistory=no';
   gratfen = window.open('', 'Gratulon', params);
   gratdok = gratfen.document;
   gratdok.writeln('<html><head><title>Gratulon</title>');
   gratdok.writeln('<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">');
   gratdok.writeln('</head>');
   gratdok.writeln('<body bgcolor=#FFFFFF onLoad="setTimeout(\'window.close()\',3500);">');
   gratdok.writeln('<center><img src="gratulon.gif" border=0></center>');
   gratdok.writeln('');
   gratdok.writeln('</body></html>');
   gratdok.close();
}


loadSources();

